

# Agents for Amazon Bedrock


The following actions are supported by Agents for Amazon Bedrock:
+  [AssociateAgentCollaborator](API_agent_AssociateAgentCollaborator.md) 
+  [AssociateAgentKnowledgeBase](API_agent_AssociateAgentKnowledgeBase.md) 
+  [CreateAgent](API_agent_CreateAgent.md) 
+  [CreateAgentActionGroup](API_agent_CreateAgentActionGroup.md) 
+  [CreateAgentAlias](API_agent_CreateAgentAlias.md) 
+  [CreateDataSource](API_agent_CreateDataSource.md) 
+  [CreateFlow](API_agent_CreateFlow.md) 
+  [CreateFlowAlias](API_agent_CreateFlowAlias.md) 
+  [CreateFlowVersion](API_agent_CreateFlowVersion.md) 
+  [CreateKnowledgeBase](API_agent_CreateKnowledgeBase.md) 
+  [CreatePrompt](API_agent_CreatePrompt.md) 
+  [CreatePromptVersion](API_agent_CreatePromptVersion.md) 
+  [DeleteAgent](API_agent_DeleteAgent.md) 
+  [DeleteAgentActionGroup](API_agent_DeleteAgentActionGroup.md) 
+  [DeleteAgentAlias](API_agent_DeleteAgentAlias.md) 
+  [DeleteAgentVersion](API_agent_DeleteAgentVersion.md) 
+  [DeleteDataSource](API_agent_DeleteDataSource.md) 
+  [DeleteFlow](API_agent_DeleteFlow.md) 
+  [DeleteFlowAlias](API_agent_DeleteFlowAlias.md) 
+  [DeleteFlowVersion](API_agent_DeleteFlowVersion.md) 
+  [DeleteKnowledgeBase](API_agent_DeleteKnowledgeBase.md) 
+  [DeleteKnowledgeBaseDocuments](API_agent_DeleteKnowledgeBaseDocuments.md) 
+  [DeletePrompt](API_agent_DeletePrompt.md) 
+  [DisassociateAgentCollaborator](API_agent_DisassociateAgentCollaborator.md) 
+  [DisassociateAgentKnowledgeBase](API_agent_DisassociateAgentKnowledgeBase.md) 
+  [GetAgent](API_agent_GetAgent.md) 
+  [GetAgentActionGroup](API_agent_GetAgentActionGroup.md) 
+  [GetAgentAlias](API_agent_GetAgentAlias.md) 
+  [GetAgentCollaborator](API_agent_GetAgentCollaborator.md) 
+  [GetAgentKnowledgeBase](API_agent_GetAgentKnowledgeBase.md) 
+  [GetAgentVersion](API_agent_GetAgentVersion.md) 
+  [GetDataSource](API_agent_GetDataSource.md) 
+  [GetFlow](API_agent_GetFlow.md) 
+  [GetFlowAlias](API_agent_GetFlowAlias.md) 
+  [GetFlowVersion](API_agent_GetFlowVersion.md) 
+  [GetIngestionJob](API_agent_GetIngestionJob.md) 
+  [GetKnowledgeBase](API_agent_GetKnowledgeBase.md) 
+  [GetKnowledgeBaseDocuments](API_agent_GetKnowledgeBaseDocuments.md) 
+  [GetPrompt](API_agent_GetPrompt.md) 
+  [IngestKnowledgeBaseDocuments](API_agent_IngestKnowledgeBaseDocuments.md) 
+  [ListAgentActionGroups](API_agent_ListAgentActionGroups.md) 
+  [ListAgentAliases](API_agent_ListAgentAliases.md) 
+  [ListAgentCollaborators](API_agent_ListAgentCollaborators.md) 
+  [ListAgentKnowledgeBases](API_agent_ListAgentKnowledgeBases.md) 
+  [ListAgents](API_agent_ListAgents.md) 
+  [ListAgentVersions](API_agent_ListAgentVersions.md) 
+  [ListDataSources](API_agent_ListDataSources.md) 
+  [ListFlowAliases](API_agent_ListFlowAliases.md) 
+  [ListFlows](API_agent_ListFlows.md) 
+  [ListFlowVersions](API_agent_ListFlowVersions.md) 
+  [ListIngestionJobs](API_agent_ListIngestionJobs.md) 
+  [ListKnowledgeBaseDocuments](API_agent_ListKnowledgeBaseDocuments.md) 
+  [ListKnowledgeBases](API_agent_ListKnowledgeBases.md) 
+  [ListPrompts](API_agent_ListPrompts.md) 
+  [ListTagsForResource](API_agent_ListTagsForResource.md) 
+  [PrepareAgent](API_agent_PrepareAgent.md) 
+  [PrepareFlow](API_agent_PrepareFlow.md) 
+  [StartIngestionJob](API_agent_StartIngestionJob.md) 
+  [StopIngestionJob](API_agent_StopIngestionJob.md) 
+  [TagResource](API_agent_TagResource.md) 
+  [UntagResource](API_agent_UntagResource.md) 
+  [UpdateAgent](API_agent_UpdateAgent.md) 
+  [UpdateAgentActionGroup](API_agent_UpdateAgentActionGroup.md) 
+  [UpdateAgentAlias](API_agent_UpdateAgentAlias.md) 
+  [UpdateAgentCollaborator](API_agent_UpdateAgentCollaborator.md) 
+  [UpdateAgentKnowledgeBase](API_agent_UpdateAgentKnowledgeBase.md) 
+  [UpdateDataSource](API_agent_UpdateDataSource.md) 
+  [UpdateFlow](API_agent_UpdateFlow.md) 
+  [UpdateFlowAlias](API_agent_UpdateFlowAlias.md) 
+  [UpdateKnowledgeBase](API_agent_UpdateKnowledgeBase.md) 
+  [UpdatePrompt](API_agent_UpdatePrompt.md) 
+  [ValidateFlowDefinition](API_agent_ValidateFlowDefinition.md) 

# AssociateAgentCollaborator


Makes an agent a collaborator for another agent.

## Request Syntax


```
PUT /agents/agentId/agentversions/agentVersion/agentcollaborators/ HTTP/1.1
Content-type: application/json

{
   "agentDescriptor": { 
      "aliasArn": "string"
   },
   "clientToken": "string",
   "collaborationInstruction": "string",
   "collaboratorName": "string",
   "relayConversationHistory": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [agentId](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-uri-agentId"></a>
The agent's ID.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

 ** [agentVersion](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-uri-agentVersion"></a>
An agent version.  
Length Constraints: Fixed length of 5.  
Pattern: `DRAFT`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [agentDescriptor](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-agentDescriptor"></a>
The alias of the collaborator agent.  
Type: [AgentDescriptor](API_agent_AgentDescriptor.md) object  
Required: Yes

 ** [clientToken](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-clientToken"></a>
A client token.  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [collaborationInstruction](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-collaborationInstruction"></a>
Instruction for the collaborator.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 4000.  
Required: Yes

 ** [collaboratorName](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-collaboratorName"></a>
A name for the collaborator.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [relayConversationHistory](#API_agent_AssociateAgentCollaborator_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-request-relayConversationHistory"></a>
A relay conversation history for the collaborator.  
Type: String  
Valid Values: `TO_COLLABORATOR | DISABLED`   
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "agentCollaborator": { 
      "agentDescriptor": { 
         "aliasArn": "string"
      },
      "agentId": "string",
      "agentVersion": "string",
      "clientToken": "string",
      "collaborationInstruction": "string",
      "collaboratorId": "string",
      "collaboratorName": "string",
      "createdAt": "string",
      "lastUpdatedAt": "string",
      "relayConversationHistory": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [agentCollaborator](#API_agent_AssociateAgentCollaborator_ResponseSyntax) **   <a name="bedrock-agent_AssociateAgentCollaborator-response-agentCollaborator"></a>
Details about the collaborator.  
Type: [AgentCollaborator](API_agent_AgentCollaborator.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/AssociateAgentCollaborator) 

# AssociateAgentKnowledgeBase


Associates a knowledge base with an agent. If a knowledge base is associated and its `indexState` is set to `Enabled`, the agent queries the knowledge base for information to augment its response to the user.

## Request Syntax


```
PUT /agents/agentId/agentversions/agentVersion/knowledgebases/ HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "knowledgeBaseId": "string",
   "knowledgeBaseState": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [agentId](#API_agent_AssociateAgentKnowledgeBase_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-request-uri-agentId"></a>
The unique identifier of the agent with which you want to associate the knowledge base.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

 ** [agentVersion](#API_agent_AssociateAgentKnowledgeBase_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-request-uri-agentVersion"></a>
The version of the agent with which you want to associate the knowledge base.  
Length Constraints: Fixed length of 5.  
Pattern: `DRAFT`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [description](#API_agent_AssociateAgentKnowledgeBase_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-request-description"></a>
A description of what the agent should use the knowledge base for.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: Yes

 ** [knowledgeBaseId](#API_agent_AssociateAgentKnowledgeBase_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-request-knowledgeBaseId"></a>
The unique identifier of the knowledge base to associate with the agent.  
Type: String  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

 ** [knowledgeBaseState](#API_agent_AssociateAgentKnowledgeBase_RequestSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-request-knowledgeBaseState"></a>
Specifies whether to use the knowledge base or not when sending an [InvokeAgent](https://docs.aws.amazon.com/bedrock/latest/APIReference/API_agent-runtime_InvokeAgent.html) request.  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "agentKnowledgeBase": { 
      "agentId": "string",
      "agentVersion": "string",
      "createdAt": "string",
      "description": "string",
      "knowledgeBaseId": "string",
      "knowledgeBaseState": "string",
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [agentKnowledgeBase](#API_agent_AssociateAgentKnowledgeBase_ResponseSyntax) **   <a name="bedrock-agent_AssociateAgentKnowledgeBase-response-agentKnowledgeBase"></a>
Contains details about the knowledge base that has been associated with the agent.  
Type: [AgentKnowledgeBase](API_agent_AgentKnowledgeBase.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/AssociateAgentKnowledgeBase) 

# CreateAgent


Creates an agent that orchestrates interactions between foundation models, data sources, software applications, user conversations, and APIs to carry out tasks to help customers.
+ Specify the following fields for security purposes.
  +  `agentResourceRoleArn` – The Amazon Resource Name (ARN) of the role with permissions to invoke API operations on an agent.
  + (Optional) `customerEncryptionKeyArn` – The Amazon Resource Name (ARN) of a AWS KMS key to encrypt the creation of the agent.
  + (Optional) `idleSessionTTLinSeconds` – Specify the number of seconds for which the agent should maintain session information. After this time expires, the subsequent `InvokeAgent` request begins a new session.
+ To enable your agent to retain conversational context across multiple sessions, include a `memoryConfiguration` object. For more information, see [Configure memory](https://docs.aws.amazon.com/bedrock/latest/userguide/agents-configure-memory.html).
+ To override the default prompt behavior for agent orchestration and to use advanced prompts, include a `promptOverrideConfiguration` object. For more information, see [Advanced prompts](https://docs.aws.amazon.com/bedrock/latest/userguide/advanced-prompts.html).
+ If your agent fails to be created, the response returns a list of `failureReasons` alongside a list of `recommendedActions` for you to troubleshoot.
+ The agent instructions will not be honored if your agent has only one knowledge base, uses default prompts, has no action group, and user input is disabled.

## Request Syntax


```
PUT /agents/ HTTP/1.1
Content-type: application/json

{
   "agentCollaboration": "string",
   "agentName": "string",
   "agentResourceRoleArn": "string",
   "clientToken": "string",
   "customerEncryptionKeyArn": "string",
   "customOrchestration": { 
      "executor": { ... }
   },
   "description": "string",
   "foundationModel": "string",
   "guardrailConfiguration": { 
      "guardrailIdentifier": "string",
      "guardrailVersion": "string"
   },
   "idleSessionTTLInSeconds": number,
   "instruction": "string",
   "memoryConfiguration": { 
      "enabledMemoryTypes": [ "string" ],
      "sessionSummaryConfiguration": { 
         "maxRecentSessions": number
      },
      "storageDays": number
   },
   "orchestrationType": "string",
   "promptOverrideConfiguration": { 
      "overrideLambda": "string",
      "promptConfigurations": [ 
         { 
            "additionalModelRequestFields": JSON value,
            "basePromptTemplate": "string",
            "foundationModel": "string",
            "inferenceConfiguration": { 
               "maximumLength": number,
               "stopSequences": [ "string" ],
               "temperature": number,
               "topK": number,
               "topP": number
            },
            "parserMode": "string",
            "promptCreationMode": "string",
            "promptState": "string",
            "promptType": "string"
         }
      ]
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [agentCollaboration](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-agentCollaboration"></a>
The agent's collaboration role.  
Type: String  
Valid Values: `SUPERVISOR | SUPERVISOR_ROUTER | DISABLED`   
Required: No

 ** [agentName](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-agentName"></a>
A name for the agent that you create.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [agentResourceRoleArn](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-agentResourceRoleArn"></a>
The Amazon Resource Name (ARN) of the IAM role with permissions to invoke API operations on the agent.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 2048.  
Pattern: `arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/.+`   
Required: No

 ** [clientToken](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [customerEncryptionKeyArn](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-customerEncryptionKeyArn"></a>
The Amazon Resource Name (ARN) of the AWS KMS key with which to encrypt the agent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}`   
Required: No

 ** [customOrchestration](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-customOrchestration"></a>
 Contains details of the custom orchestration configured for the agent.   
Type: [CustomOrchestration](API_agent_CustomOrchestration.md) object  
Required: No

 ** [description](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-description"></a>
A description of the agent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [foundationModel](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-foundationModel"></a>
The identifier for the model that you want to be used for orchestration by the agent you create.  
The `modelId` to provide depends on the type of model or throughput that you use:  
+ If you use a base model, specify the model ID or its ARN. For a list of model IDs for base models, see [Amazon Bedrock base model IDs (on-demand throughput)](https://docs.aws.amazon.com/bedrock/latest/userguide/model-ids.html#model-ids-arns) in the Amazon Bedrock User Guide.
+ If you use an inference profile, specify the inference profile ID or its ARN. For a list of inference profile IDs, see [Supported Regions and models for cross-region inference](https://docs.aws.amazon.com/bedrock/latest/userguide/cross-region-inference-support.html) in the Amazon Bedrock User Guide.
+ If you use a provisioned model, specify the ARN of the Provisioned Throughput. For more information, see [Run inference using a Provisioned Throughput](https://docs.aws.amazon.com/bedrock/latest/userguide/prov-thru-use.html) in the Amazon Bedrock User Guide.
+ If you use a custom model, first purchase Provisioned Throughput for it. Then specify the ARN of the resulting provisioned model. For more information, see [Use a custom model in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/model-customization-use.html) in the Amazon Bedrock User Guide.
+ If you use an [imported model](https://docs.aws.amazon.com/bedrock/latest/userguide/model-customization-import-model.html), specify the ARN of the imported model. You can get the model ARN from a successful call to [CreateModelImportJob](https://docs.aws.amazon.com/bedrock/latest/APIReference/API_CreateModelImportJob.html) or from the Imported models page in the Amazon Bedrock console.
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `(arn:aws(-[^:]{1,12})?:(bedrock|sagemaker):[a-z0-9-]{1,20}:([0-9]{12})?:([a-z-]+/)?)?([a-zA-Z0-9.-]{1,63}){0,2}(([:][a-z0-9-]{1,63}){0,2})?(/[a-z0-9]{1,12})?`   
Required: No

 ** [guardrailConfiguration](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-guardrailConfiguration"></a>
The unique Guardrail configuration assigned to the agent when it is created.  
Type: [GuardrailConfiguration](API_agent_GuardrailConfiguration.md) object  
Required: No

 ** [idleSessionTTLInSeconds](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-idleSessionTTLInSeconds"></a>
The number of seconds for which Amazon Bedrock keeps information about a user's conversation with the agent.  
A user interaction remains active for the amount of time specified. If no conversation occurs during this time, the session expires and Amazon Bedrock deletes any data provided before the timeout.  
Type: Integer  
Valid Range: Minimum value of 60. Maximum value of 5400.  
Required: No

 ** [instruction](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-instruction"></a>
Instructions that tell the agent what it should do and how it should interact with users.  
Type: String  
Length Constraints: Minimum length of 40. Maximum length of 4000.  
Required: No

 ** [memoryConfiguration](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-memoryConfiguration"></a>
 Contains the details of the memory configured for the agent.  
Type: [MemoryConfiguration](API_agent_MemoryConfiguration.md) object  
Required: No

 ** [orchestrationType](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-orchestrationType"></a>
 Specifies the type of orchestration strategy for the agent. This is set to `DEFAULT` orchestration type, by default.   
Type: String  
Valid Values: `DEFAULT | CUSTOM_ORCHESTRATION`   
Required: No

 ** [promptOverrideConfiguration](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-promptOverrideConfiguration"></a>
Contains configurations to override prompts in different parts of an agent sequence. For more information, see [Advanced prompts](https://docs.aws.amazon.com/bedrock/latest/userguide/advanced-prompts.html).  
Type: [PromptOverrideConfiguration](API_agent_PromptOverrideConfiguration.md) object  
Required: No

 ** [tags](#API_agent_CreateAgent_RequestSyntax) **   <a name="bedrock-agent_CreateAgent-request-tags"></a>
Any tags that you want to attach to the agent.  
Type: String to string map  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Required: No

## Response Syntax


```
HTTP/1.1 202
Content-type: application/json

{
   "agent": { 
      "agentArn": "string",
      "agentCollaboration": "string",
      "agentId": "string",
      "agentName": "string",
      "agentResourceRoleArn": "string",
      "agentStatus": "string",
      "agentVersion": "string",
      "clientToken": "string",
      "createdAt": "string",
      "customerEncryptionKeyArn": "string",
      "customOrchestration": { 
         "executor": { ... }
      },
      "description": "string",
      "failureReasons": [ "string" ],
      "foundationModel": "string",
      "guardrailConfiguration": { 
         "guardrailIdentifier": "string",
         "guardrailVersion": "string"
      },
      "idleSessionTTLInSeconds": number,
      "instruction": "string",
      "memoryConfiguration": { 
         "enabledMemoryTypes": [ "string" ],
         "sessionSummaryConfiguration": { 
            "maxRecentSessions": number
         },
         "storageDays": number
      },
      "orchestrationType": "string",
      "preparedAt": "string",
      "promptOverrideConfiguration": { 
         "overrideLambda": "string",
         "promptConfigurations": [ 
            { 
               "additionalModelRequestFields": JSON value,
               "basePromptTemplate": "string",
               "foundationModel": "string",
               "inferenceConfiguration": { 
                  "maximumLength": number,
                  "stopSequences": [ "string" ],
                  "temperature": number,
                  "topK": number,
                  "topP": number
               },
               "parserMode": "string",
               "promptCreationMode": "string",
               "promptState": "string",
               "promptType": "string"
            }
         ]
      },
      "recommendedActions": [ "string" ],
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

 ** [agent](#API_agent_CreateAgent_ResponseSyntax) **   <a name="bedrock-agent_CreateAgent-response-agent"></a>
Contains details about the agent created.  
Type: [Agent](API_agent_Agent.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## Examples


### Example request


This example illustrates one usage of CreateAgent.

```
PUT /agents/ HTTP/1.1
Content-type: application/json

{
  "agentName": "o1nvve1",
  "agentResourceRoleArn": "arn:aws:iam::123456789012:role/AmazonBedrockExecutionRoleForAgents_user",
  "instruction": "You are an IT agent who solves customer's problems",
  "description": "Description is here",
  "idleSessionTTLInSeconds": 900,
  "foundationModel": "anthropic.claude-v2"
}
```

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateAgent) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateAgent) 

# CreateAgentActionGroup


Creates an action group for an agent. An action group represents the actions that an agent can carry out for the customer by defining the APIs that an agent can call and the logic for calling them.

To allow your agent to request the user for additional information when trying to complete a task, add an action group with the `parentActionGroupSignature` field set to `AMAZON.UserInput`. 

To allow your agent to generate, run, and troubleshoot code when trying to complete a task, add an action group with the `parentActionGroupSignature` field set to `AMAZON.CodeInterpreter`. 

You must leave the `description`, `apiSchema`, and `actionGroupExecutor` fields blank for this action group. During orchestration, if your agent determines that it needs to invoke an API in an action group, but doesn't have enough information to complete the API request, it will invoke this action group instead and return an [Observation](https://docs.aws.amazon.com/bedrock/latest/APIReference/API_agent-runtime_Observation.html) reprompting the user for more information.

## Request Syntax


```
PUT /agents/agentId/agentversions/agentVersion/actiongroups/ HTTP/1.1
Content-type: application/json

{
   "actionGroupExecutor": { ... },
   "actionGroupName": "string",
   "actionGroupState": "string",
   "apiSchema": { ... },
   "clientToken": "string",
   "description": "string",
   "functionSchema": { ... },
   "parentActionGroupSignature": "string",
   "parentActionGroupSignatureParams": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [agentId](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-uri-agentId"></a>
The unique identifier of the agent for which to create the action group.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

 ** [agentVersion](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-uri-agentVersion"></a>
The version of the agent for which to create the action group.  
Length Constraints: Fixed length of 5.  
Pattern: `DRAFT`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [actionGroupExecutor](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-actionGroupExecutor"></a>
The Amazon Resource Name (ARN) of the Lambda function containing the business logic that is carried out upon invoking the action or the custom control method for handling the information elicited from the user.  
Type: [ActionGroupExecutor](API_agent_ActionGroupExecutor.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [actionGroupName](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-actionGroupName"></a>
The name to give the action group.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [actionGroupState](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-actionGroupState"></a>
Specifies whether the action group is available for the agent to invoke or not when sending an [InvokeAgent](https://docs.aws.amazon.com/bedrock/latest/APIReference/API_agent-runtime_InvokeAgent.html) request.  
Type: String  
Valid Values: `ENABLED | DISABLED`   
Required: No

 ** [apiSchema](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-apiSchema"></a>
Contains either details about the S3 object containing the OpenAPI schema for the action group or the JSON or YAML-formatted payload defining the schema. For more information, see [Action group OpenAPI schemas](https://docs.aws.amazon.com/bedrock/latest/userguide/agents-api-schema.html).  
Type: [APISchema](API_agent_APISchema.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [clientToken](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [description](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-description"></a>
A description of the action group.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [functionSchema](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-functionSchema"></a>
Contains details about the function schema for the action group or the JSON or YAML-formatted payload defining the schema.  
Type: [FunctionSchema](API_agent_FunctionSchema.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [parentActionGroupSignature](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-parentActionGroupSignature"></a>
Specify a built-in or computer use action for this action group. If you specify a value, you must leave the `description`, `apiSchema`, and `actionGroupExecutor` fields empty for this action group.   
+ To allow your agent to request the user for additional information when trying to complete a task, set this field to `AMAZON.UserInput`. 
+ To allow your agent to generate, run, and troubleshoot code when trying to complete a task, set this field to `AMAZON.CodeInterpreter`.
+ To allow your agent to use an Anthropic computer use tool, specify one of the following values. 
**Important**  
 Computer use is a new Anthropic Claude model capability (in beta) available with Anthropic Claude 3.7 Sonnet and Claude 3.5 Sonnet v2 only. When operating computer use functionality, we recommend taking additional security precautions, such as executing computer actions in virtual environments with restricted data access and limited internet connectivity. For more information, see [Configure an Amazon Bedrock Agent to complete tasks with computer use tools](https://docs.aws.amazon.com/bedrock/latest/userguide/agents-computer-use.html). 
  +  `ANTHROPIC.Computer` - Gives the agent permission to use the mouse and keyboard and take screenshots.
  +  `ANTHROPIC.TextEditor` - Gives the agent permission to view, create and edit files.
  +  `ANTHROPIC.Bash` - Gives the agent permission to run commands in a bash shell.
Type: String  
Valid Values: `AMAZON.UserInput | AMAZON.CodeInterpreter | ANTHROPIC.Computer | ANTHROPIC.Bash | ANTHROPIC.TextEditor`   
Required: No

 ** [parentActionGroupSignatureParams](#API_agent_CreateAgentActionGroup_RequestSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-request-parentActionGroupSignatureParams"></a>
The configuration settings for a computer use action.  
 Computer use is a new Anthropic Claude model capability (in beta) available with Anthropic Claude 3.7 Sonnet and Claude 3.5 Sonnet v2 only. For more information, see [Configure an Amazon Bedrock Agent to complete tasks with computer use tools](https://docs.aws.amazon.com/bedrock/latest/userguide/agents-computer-use.html). 
Type: String to string map  
Key Length Constraints: Minimum length of 0. Maximum length of 100.  
Value Length Constraints: Minimum length of 0. Maximum length of 100.  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "agentActionGroup": { 
      "actionGroupExecutor": { ... },
      "actionGroupId": "string",
      "actionGroupName": "string",
      "actionGroupState": "string",
      "agentId": "string",
      "agentVersion": "string",
      "apiSchema": { ... },
      "clientToken": "string",
      "createdAt": "string",
      "description": "string",
      "functionSchema": { ... },
      "parentActionGroupSignatureParams": { 
         "string" : "string" 
      },
      "parentActionSignature": "string",
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [agentActionGroup](#API_agent_CreateAgentActionGroup_ResponseSyntax) **   <a name="bedrock-agent_CreateAgentActionGroup-response-agentActionGroup"></a>
Contains details about the action group that was created.  
Type: [AgentActionGroup](API_agent_AgentActionGroup.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## Examples


### Create an action group using an OpenAPI schema and a Lambda function


The following example creates an action group using an OpenAPI schema uploaded to an Amazon S3 bucket and sends the information elicited from the user to a Lambda function.

```
PUT /agents/AGENT12345/agentversions/DRAFT/actiongroups/ HTTP/1.1
Content-type: application/json

{
   "actionGroupName": "Test Action",
   "actionGroupState": "ENABLED",
   "apiSchema": {
        "s3": {
            "s3BucketName": "apischema-s3",
            "s3ObjectKey": "it_agent_openapi.json"
        }
    },
   "description": "Testing latest IT Management action",
   "actionGroupExecutor": {
        "lambda": "arn:aws:lambda:us-west-2:123456789012:function:ItAgentLambda"
    }
}
```

### Create an action group using an OpenAPI schema and return control


The following example creates an action group using an OpenAPI schema uploaded to an Amazon S3 bucket and returns control by sending the information in the `InvokeAgent` response.

```
{
    "actionGroupName": "WeatherAPIs",
    "description": "Actions to get current weather and historical trends for a location",
    "actionGroupState": "ENABLED",
    "apiSchema": {
        "s3": {
            "s3BucketName": "openapi-spec-iad",
            "s3ObjectKey": "get_weather_openapi.yaml"
        }
    },
    "actionGroupExecutor": {
        "customControl": "RETURN_CONTROL"
    }
}
```

### Create an action group using function details and return control


The following example creates an action group using function details and returns control by sending the information in the `InvokeAgent` response

```
PUT /agents/AGENT12345/agentversions/DRAFT/actiongroups/ HTTP/1.1
Content-type: application/json

{
    "actionGroupName": "OrderManagementAction",
    "description": "Action to get the order history, product details, product availability and to update the order",
    "actionGroupState": "ENABLED",
    "actionGroupExecutor": {
        "customControl": "RETURN_CONTROL"
    },
    "functionSchema": {
        "functions": [{
            "name": "GetOrderDetails",
            "description": "Retrieves the order history for a given OrderId and returns productId, color, productName, size, productType, quantity, and status."
            "parameters": {
                "orderId": {
                    "type": "string",
                    "required": true
                }
            }
        }]
    }
}
```

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateAgentActionGroup) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateAgentActionGroup) 

# CreateAgentAlias


Creates an alias of an agent that can be used to deploy the agent.

## Request Syntax


```
PUT /agents/agentId/agentaliases/ HTTP/1.1
Content-type: application/json

{
   "agentAliasName": "string",
   "clientToken": "string",
   "description": "string",
   "routingConfiguration": [ 
      { 
         "agentVersion": "string",
         "provisionedThroughput": "string"
      }
   ],
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [agentId](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-uri-agentId"></a>
The unique identifier of the agent.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [agentAliasName](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-agentAliasName"></a>
The name of the alias.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [clientToken](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [description](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-description"></a>
A description of the alias of the agent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [routingConfiguration](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-routingConfiguration"></a>
Contains details about the routing configuration of the alias.  
Type: Array of [AgentAliasRoutingConfigurationListItem](API_agent_AgentAliasRoutingConfigurationListItem.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 1 item.  
Required: No

 ** [tags](#API_agent_CreateAgentAlias_RequestSyntax) **   <a name="bedrock-agent_CreateAgentAlias-request-tags"></a>
Any tags that you want to attach to the alias of the agent.  
Type: String to string map  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Required: No

## Response Syntax


```
HTTP/1.1 202
Content-type: application/json

{
   "agentAlias": { 
      "agentAliasArn": "string",
      "agentAliasHistoryEvents": [ 
         { 
            "endDate": "string",
            "routingConfiguration": [ 
               { 
                  "agentVersion": "string",
                  "provisionedThroughput": "string"
               }
            ],
            "startDate": "string"
         }
      ],
      "agentAliasId": "string",
      "agentAliasName": "string",
      "agentAliasStatus": "string",
      "agentId": "string",
      "aliasInvocationState": "string",
      "clientToken": "string",
      "createdAt": "string",
      "description": "string",
      "failureReasons": [ "string" ],
      "routingConfiguration": [ 
         { 
            "agentVersion": "string",
            "provisionedThroughput": "string"
         }
      ],
      "updatedAt": "string"
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

 ** [agentAlias](#API_agent_CreateAgentAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateAgentAlias-response-agentAlias"></a>
Contains details about the alias that was created.  
Type: [AgentAlias](API_agent_AgentAlias.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## Examples


### Example request


This example illustrates one usage of CreateAgentAlias.

```
PUT /agents/ABCDEFGHIJ/agentaliases/ HTTP/1.1
Content-type: application/json

{
 "agentAliasName": "TestName",
 "description": "Alias is test"
}
```

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateAgentAlias) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateAgentAlias) 

# CreateDataSource


Connects a knowledge base to a data source. You specify the configuration for the specific data source service in the `dataSourceConfiguration` field.

**Important**  
You can't change the `chunkingConfiguration` after you create the data source connector.

## Request Syntax


```
PUT /knowledgebases/knowledgeBaseId/datasources/ HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "dataDeletionPolicy": "string",
   "dataSourceConfiguration": { 
      "confluenceConfiguration": { 
         "crawlerConfiguration": { 
            "filterConfiguration": { 
               "patternObjectFilter": { 
                  "filters": [ 
                     { 
                        "exclusionFilters": [ "string" ],
                        "inclusionFilters": [ "string" ],
                        "objectType": "string"
                     }
                  ]
               },
               "type": "string"
            }
         },
         "sourceConfiguration": { 
            "authType": "string",
            "credentialsSecretArn": "string",
            "hostType": "string",
            "hostUrl": "string"
         }
      },
      "s3Configuration": { 
         "bucketArn": "string",
         "bucketOwnerAccountId": "string",
         "inclusionPrefixes": [ "string" ]
      },
      "salesforceConfiguration": { 
         "crawlerConfiguration": { 
            "filterConfiguration": { 
               "patternObjectFilter": { 
                  "filters": [ 
                     { 
                        "exclusionFilters": [ "string" ],
                        "inclusionFilters": [ "string" ],
                        "objectType": "string"
                     }
                  ]
               },
               "type": "string"
            }
         },
         "sourceConfiguration": { 
            "authType": "string",
            "credentialsSecretArn": "string",
            "hostUrl": "string"
         }
      },
      "sharePointConfiguration": { 
         "crawlerConfiguration": { 
            "filterConfiguration": { 
               "patternObjectFilter": { 
                  "filters": [ 
                     { 
                        "exclusionFilters": [ "string" ],
                        "inclusionFilters": [ "string" ],
                        "objectType": "string"
                     }
                  ]
               },
               "type": "string"
            }
         },
         "sourceConfiguration": { 
            "authType": "string",
            "credentialsSecretArn": "string",
            "domain": "string",
            "hostType": "string",
            "siteUrls": [ "string" ],
            "tenantId": "string"
         }
      },
      "type": "string",
      "webConfiguration": { 
         "crawlerConfiguration": { 
            "crawlerLimits": { 
               "maxPages": number,
               "rateLimit": number
            },
            "exclusionFilters": [ "string" ],
            "inclusionFilters": [ "string" ],
            "scope": "string",
            "userAgent": "string",
            "userAgentHeader": "string"
         },
         "sourceConfiguration": { 
            "urlConfiguration": { 
               "seedUrls": [ 
                  { 
                     "url": "string"
                  }
               ]
            }
         }
      }
   },
   "description": "string",
   "name": "string",
   "serverSideEncryptionConfiguration": { 
      "kmsKeyArn": "string"
   },
   "vectorIngestionConfiguration": { 
      "chunkingConfiguration": { 
         "chunkingStrategy": "string",
         "fixedSizeChunkingConfiguration": { 
            "maxTokens": number,
            "overlapPercentage": number
         },
         "hierarchicalChunkingConfiguration": { 
            "levelConfigurations": [ 
               { 
                  "maxTokens": number
               }
            ],
            "overlapTokens": number
         },
         "semanticChunkingConfiguration": { 
            "breakpointPercentileThreshold": number,
            "bufferSize": number,
            "maxTokens": number
         }
      },
      "contextEnrichmentConfiguration": { 
         "bedrockFoundationModelConfiguration": { 
            "enrichmentStrategyConfiguration": { 
               "method": "string"
            },
            "modelArn": "string"
         },
         "type": "string"
      },
      "customTransformationConfiguration": { 
         "intermediateStorage": { 
            "s3Location": { 
               "uri": "string"
            }
         },
         "transformations": [ 
            { 
               "stepToApply": "string",
               "transformationFunction": { 
                  "transformationLambdaConfiguration": { 
                     "lambdaArn": "string"
                  }
               }
            }
         ]
      },
      "parsingConfiguration": { 
         "bedrockDataAutomationConfiguration": { 
            "parsingModality": "string"
         },
         "bedrockFoundationModelConfiguration": { 
            "modelArn": "string",
            "parsingModality": "string",
            "parsingPrompt": { 
               "parsingPromptText": "string"
            }
         },
         "parsingStrategy": "string"
      }
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [knowledgeBaseId](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-uri-knowledgeBaseId"></a>
The unique identifier of the knowledge base to which to add the data source.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [dataDeletionPolicy](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-dataDeletionPolicy"></a>
The data deletion policy for the data source.  
You can set the data deletion policy to:  
+ DELETE: Deletes all data from your data source that’s converted into vector embeddings upon deletion of a knowledge base or data source resource. Note that the **vector store itself is not deleted**, only the data. This flag is ignored if an AWS account is deleted.
+ RETAIN: Retains all data from your data source that’s converted into vector embeddings upon deletion of a knowledge base or data source resource. Note that the **vector store itself is not deleted** if you delete a knowledge base or data source resource.
Type: String  
Valid Values: `RETAIN | DELETE`   
Required: No

 ** [dataSourceConfiguration](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-dataSourceConfiguration"></a>
The connection configuration for the data source.  
Type: [DataSourceConfiguration](API_agent_DataSourceConfiguration.md) object  
Required: Yes

 ** [description](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-description"></a>
A description of the data source.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [name](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-name"></a>
The name of the data source.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [serverSideEncryptionConfiguration](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-serverSideEncryptionConfiguration"></a>
Contains details about the server-side encryption for the data source.  
Type: [ServerSideEncryptionConfiguration](API_agent_ServerSideEncryptionConfiguration.md) object  
Required: No

 ** [vectorIngestionConfiguration](#API_agent_CreateDataSource_RequestSyntax) **   <a name="bedrock-agent_CreateDataSource-request-vectorIngestionConfiguration"></a>
Contains details about how to ingest the documents in the data source.  
Type: [VectorIngestionConfiguration](API_agent_VectorIngestionConfiguration.md) object  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "dataSource": { 
      "createdAt": "string",
      "dataDeletionPolicy": "string",
      "dataSourceConfiguration": { 
         "confluenceConfiguration": { 
            "crawlerConfiguration": { 
               "filterConfiguration": { 
                  "patternObjectFilter": { 
                     "filters": [ 
                        { 
                           "exclusionFilters": [ "string" ],
                           "inclusionFilters": [ "string" ],
                           "objectType": "string"
                        }
                     ]
                  },
                  "type": "string"
               }
            },
            "sourceConfiguration": { 
               "authType": "string",
               "credentialsSecretArn": "string",
               "hostType": "string",
               "hostUrl": "string"
            }
         },
         "s3Configuration": { 
            "bucketArn": "string",
            "bucketOwnerAccountId": "string",
            "inclusionPrefixes": [ "string" ]
         },
         "salesforceConfiguration": { 
            "crawlerConfiguration": { 
               "filterConfiguration": { 
                  "patternObjectFilter": { 
                     "filters": [ 
                        { 
                           "exclusionFilters": [ "string" ],
                           "inclusionFilters": [ "string" ],
                           "objectType": "string"
                        }
                     ]
                  },
                  "type": "string"
               }
            },
            "sourceConfiguration": { 
               "authType": "string",
               "credentialsSecretArn": "string",
               "hostUrl": "string"
            }
         },
         "sharePointConfiguration": { 
            "crawlerConfiguration": { 
               "filterConfiguration": { 
                  "patternObjectFilter": { 
                     "filters": [ 
                        { 
                           "exclusionFilters": [ "string" ],
                           "inclusionFilters": [ "string" ],
                           "objectType": "string"
                        }
                     ]
                  },
                  "type": "string"
               }
            },
            "sourceConfiguration": { 
               "authType": "string",
               "credentialsSecretArn": "string",
               "domain": "string",
               "hostType": "string",
               "siteUrls": [ "string" ],
               "tenantId": "string"
            }
         },
         "type": "string",
         "webConfiguration": { 
            "crawlerConfiguration": { 
               "crawlerLimits": { 
                  "maxPages": number,
                  "rateLimit": number
               },
               "exclusionFilters": [ "string" ],
               "inclusionFilters": [ "string" ],
               "scope": "string",
               "userAgent": "string",
               "userAgentHeader": "string"
            },
            "sourceConfiguration": { 
               "urlConfiguration": { 
                  "seedUrls": [ 
                     { 
                        "url": "string"
                     }
                  ]
               }
            }
         }
      },
      "dataSourceId": "string",
      "description": "string",
      "failureReasons": [ "string" ],
      "knowledgeBaseId": "string",
      "name": "string",
      "serverSideEncryptionConfiguration": { 
         "kmsKeyArn": "string"
      },
      "status": "string",
      "updatedAt": "string",
      "vectorIngestionConfiguration": { 
         "chunkingConfiguration": { 
            "chunkingStrategy": "string",
            "fixedSizeChunkingConfiguration": { 
               "maxTokens": number,
               "overlapPercentage": number
            },
            "hierarchicalChunkingConfiguration": { 
               "levelConfigurations": [ 
                  { 
                     "maxTokens": number
                  }
               ],
               "overlapTokens": number
            },
            "semanticChunkingConfiguration": { 
               "breakpointPercentileThreshold": number,
               "bufferSize": number,
               "maxTokens": number
            }
         },
         "contextEnrichmentConfiguration": { 
            "bedrockFoundationModelConfiguration": { 
               "enrichmentStrategyConfiguration": { 
                  "method": "string"
               },
               "modelArn": "string"
            },
            "type": "string"
         },
         "customTransformationConfiguration": { 
            "intermediateStorage": { 
               "s3Location": { 
                  "uri": "string"
               }
            },
            "transformations": [ 
               { 
                  "stepToApply": "string",
                  "transformationFunction": { 
                     "transformationLambdaConfiguration": { 
                        "lambdaArn": "string"
                     }
                  }
               }
            ]
         },
         "parsingConfiguration": { 
            "bedrockDataAutomationConfiguration": { 
               "parsingModality": "string"
            },
            "bedrockFoundationModelConfiguration": { 
               "modelArn": "string",
               "parsingModality": "string",
               "parsingPrompt": { 
                  "parsingPromptText": "string"
               }
            },
            "parsingStrategy": "string"
         }
      }
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [dataSource](#API_agent_CreateDataSource_ResponseSyntax) **   <a name="bedrock-agent_CreateDataSource-response-dataSource"></a>
Contains details about the data source.  
Type: [DataSource](API_agent_DataSource.md) object

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateDataSource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateDataSource) 

# CreateFlow


Creates a prompt flow that you can use to send an input through various steps to yield an output. Configure nodes, each of which corresponds to a step of the flow, and create connections between the nodes to create paths to different outputs. For more information, see [How it works](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-how-it-works.html) and [Create a flow in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-create.html) in the Amazon Bedrock User Guide.

## Request Syntax


```
POST /flows/ HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "customerEncryptionKeyArn": "string",
   "definition": { 
      "connections": [ 
         { 
            "configuration": { ... },
            "name": "string",
            "source": "string",
            "target": "string",
            "type": "string"
         }
      ],
      "nodes": [ 
         { 
            "configuration": { ... },
            "inputs": [ 
               { 
                  "category": "string",
                  "expression": "string",
                  "name": "string",
                  "type": "string"
               }
            ],
            "name": "string",
            "outputs": [ 
               { 
                  "name": "string",
                  "type": "string"
               }
            ],
            "type": "string"
         }
      ]
   },
   "description": "string",
   "executionRoleArn": "string",
   "name": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [customerEncryptionKeyArn](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-customerEncryptionKeyArn"></a>
The Amazon Resource Name (ARN) of the KMS key to encrypt the flow.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}`   
Required: No

 ** [definition](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-definition"></a>
A definition of the nodes and connections between nodes in the flow.  
Type: [FlowDefinition](API_agent_FlowDefinition.md) object  
Required: No

 ** [description](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-description"></a>
A description for the flow.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [executionRoleArn](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-executionRoleArn"></a>
The Amazon Resource Name (ARN) of the service role with permissions to create and manage a flow. For more information, see [Create a service role for flows in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-permissions.html) in the Amazon Bedrock User Guide.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 2048.  
Pattern: `arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/(service-role/)?.+`   
Required: Yes

 ** [name](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-name"></a>
A name for the flow.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [tags](#API_agent_CreateFlow_RequestSyntax) **   <a name="bedrock-agent_CreateFlow-request-tags"></a>
Any tags that you want to attach to the flow. For more information, see [Tagging resources in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/tagging.html).  
Type: String to string map  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "createdAt": "string",
   "customerEncryptionKeyArn": "string",
   "definition": { 
      "connections": [ 
         { 
            "configuration": { ... },
            "name": "string",
            "source": "string",
            "target": "string",
            "type": "string"
         }
      ],
      "nodes": [ 
         { 
            "configuration": { ... },
            "inputs": [ 
               { 
                  "category": "string",
                  "expression": "string",
                  "name": "string",
                  "type": "string"
               }
            ],
            "name": "string",
            "outputs": [ 
               { 
                  "name": "string",
                  "type": "string"
               }
            ],
            "type": "string"
         }
      ]
   },
   "description": "string",
   "executionRoleArn": "string",
   "id": "string",
   "name": "string",
   "status": "string",
   "updatedAt": "string",
   "version": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-arn"></a>
The Amazon Resource Name (ARN) of the flow.  
Type: String  
Pattern: `arn:aws:bedrock:[a-z0-9-]{1,20}:[0-9]{12}:flow/[0-9a-zA-Z]{10}` 

 ** [createdAt](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-createdAt"></a>
The time at which the flow was created.  
Type: Timestamp

 ** [customerEncryptionKeyArn](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-customerEncryptionKeyArn"></a>
The Amazon Resource Name (ARN) of the KMS key that you encrypted the flow with.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [definition](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-definition"></a>
A definition of the nodes and connections between nodes in the flow.  
Type: [FlowDefinition](API_agent_FlowDefinition.md) object

 ** [description](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-description"></a>
The description of the flow.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.

 ** [executionRoleArn](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-executionRoleArn"></a>
The Amazon Resource Name (ARN) of the service role with permissions to create a flow. For more information, see [Create a service role for flows in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-permissions.html) in the Amazon Bedrock User Guide.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 2048.  
Pattern: `arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/(service-role/)?.+` 

 ** [id](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-id"></a>
The unique identifier of the flow.  
Type: String  
Pattern: `[0-9a-zA-Z]{10}` 

 ** [name](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-name"></a>
The name of the flow.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}` 

 ** [status](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-status"></a>
The status of the flow. When you submit this request, the status will be `NotPrepared`. If creation fails, the status becomes `Failed`.  
Type: String  
Valid Values: `Failed | Prepared | Preparing | NotPrepared` 

 ** [updatedAt](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-updatedAt"></a>
The time at which the flow was last updated.  
Type: Timestamp

 ** [version](#API_agent_CreateFlow_ResponseSyntax) **   <a name="bedrock-agent_CreateFlow-response-version"></a>
The version of the flow. When you create a flow, the version created is the `DRAFT` version.  
Type: String  
Length Constraints: Fixed length of 5.  
Pattern: `DRAFT` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateFlow) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateFlow) 

# CreateFlowAlias


Creates an alias of a flow for deployment. For more information, see [Deploy a flow in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-deploy.html) in the Amazon Bedrock User Guide.

## Request Syntax


```
POST /flows/flowIdentifier/aliases HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "concurrencyConfiguration": { 
      "maxConcurrency": number,
      "type": "string"
   },
   "description": "string",
   "name": "string",
   "routingConfiguration": [ 
      { 
         "flowVersion": "string"
      }
   ],
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [flowIdentifier](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-uri-flowIdentifier"></a>
The unique identifier of the flow for which to create an alias.  
Pattern: `(arn:aws:bedrock:[a-z0-9-]{1,20}:[0-9]{12}:flow/[0-9a-zA-Z]{10})|([0-9a-zA-Z]{10})`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [concurrencyConfiguration](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-concurrencyConfiguration"></a>
The configuration that specifies how nodes in the flow are executed in parallel.  
Type: [FlowAliasConcurrencyConfiguration](API_agent_FlowAliasConcurrencyConfiguration.md) object  
Required: No

 ** [description](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-description"></a>
A description for the alias.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

 ** [name](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-name"></a>
A name for the alias.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}`   
Required: Yes

 ** [routingConfiguration](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-routingConfiguration"></a>
Contains information about the version to which to map the alias.  
Type: Array of [FlowAliasRoutingConfigurationListItem](API_agent_FlowAliasRoutingConfigurationListItem.md) objects  
Array Members: Fixed number of 1 item.  
Required: Yes

 ** [tags](#API_agent_CreateFlowAlias_RequestSyntax) **   <a name="bedrock-agent_CreateFlowAlias-request-tags"></a>
Any tags that you want to attach to the alias of the flow. For more information, see [Tagging resources in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/tagging.html).  
Type: String to string map  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[a-zA-Z0-9\s._:/=+@-]*`   
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "concurrencyConfiguration": { 
      "maxConcurrency": number,
      "type": "string"
   },
   "createdAt": "string",
   "description": "string",
   "flowId": "string",
   "id": "string",
   "name": "string",
   "routingConfiguration": [ 
      { 
         "flowVersion": "string"
      }
   ],
   "updatedAt": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-arn"></a>
The Amazon Resource Name (ARN) of the alias.  
Type: String  
Pattern: `arn:aws:bedrock:[a-z0-9-]{1,20}:[0-9]{12}:flow/[0-9a-zA-Z]{10}/alias/(TSTALIASID|[0-9a-zA-Z]{10})` 

 ** [concurrencyConfiguration](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-concurrencyConfiguration"></a>
The configuration that specifies how nodes in the flow are executed in parallel.  
Type: [FlowAliasConcurrencyConfiguration](API_agent_FlowAliasConcurrencyConfiguration.md) object

 ** [createdAt](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-createdAt"></a>
The time at which the alias was created.  
Type: Timestamp

 ** [description](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-description"></a>
The description of the alias.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.

 ** [flowId](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-flowId"></a>
The unique identifier of the flow that the alias belongs to.  
Type: String  
Pattern: `[0-9a-zA-Z]{10}` 

 ** [id](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-id"></a>
The unique identifier of the alias.  
Type: String  
Pattern: `(TSTALIASID|[0-9a-zA-Z]{10})` 

 ** [name](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-name"></a>
The name of the alias.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}` 

 ** [routingConfiguration](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-routingConfiguration"></a>
Contains information about the version that the alias is mapped to.  
Type: Array of [FlowAliasRoutingConfigurationListItem](API_agent_FlowAliasRoutingConfigurationListItem.md) objects  
Array Members: Fixed number of 1 item.

 ** [updatedAt](#API_agent_CreateFlowAlias_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowAlias-response-updatedAt"></a>
The time at which the alias of the flow was last updated.  
Type: Timestamp

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateFlowAlias) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateFlowAlias) 

# CreateFlowVersion


Creates a version of the flow that you can deploy. For more information, see [Deploy a flow in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-deploy.html) in the Amazon Bedrock User Guide.

## Request Syntax


```
POST /flows/flowIdentifier/versions HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "description": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [flowIdentifier](#API_agent_CreateFlowVersion_RequestSyntax) **   <a name="bedrock-agent_CreateFlowVersion-request-uri-flowIdentifier"></a>
The unique identifier of the flow that you want to create a version of.  
Pattern: `(arn:aws:bedrock:[a-z0-9-]{1,20}:[0-9]{12}:flow/[0-9a-zA-Z]{10})|([0-9a-zA-Z]{10})`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_agent_CreateFlowVersion_RequestSyntax) **   <a name="bedrock-agent_CreateFlowVersion-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [description](#API_agent_CreateFlowVersion_RequestSyntax) **   <a name="bedrock-agent_CreateFlowVersion-request-description"></a>
A description of the version of the flow.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "arn": "string",
   "createdAt": "string",
   "customerEncryptionKeyArn": "string",
   "definition": { 
      "connections": [ 
         { 
            "configuration": { ... },
            "name": "string",
            "source": "string",
            "target": "string",
            "type": "string"
         }
      ],
      "nodes": [ 
         { 
            "configuration": { ... },
            "inputs": [ 
               { 
                  "category": "string",
                  "expression": "string",
                  "name": "string",
                  "type": "string"
               }
            ],
            "name": "string",
            "outputs": [ 
               { 
                  "name": "string",
                  "type": "string"
               }
            ],
            "type": "string"
         }
      ]
   },
   "description": "string",
   "executionRoleArn": "string",
   "id": "string",
   "name": "string",
   "status": "string",
   "version": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-arn"></a>
The Amazon Resource Name (ARN) of the flow.  
Type: String  
Pattern: `arn:aws:bedrock:[a-z0-9-]{1,20}:[0-9]{12}:flow/[0-9a-zA-Z]{10}` 

 ** [createdAt](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-createdAt"></a>
The time at which the flow was created.  
Type: Timestamp

 ** [customerEncryptionKeyArn](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-customerEncryptionKeyArn"></a>
The KMS key that the flow is encrypted with.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}` 

 ** [definition](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-definition"></a>
A definition of the nodes and connections in the flow.  
Type: [FlowDefinition](API_agent_FlowDefinition.md) object

 ** [description](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-description"></a>
The description of the version.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 200.

 ** [executionRoleArn](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-executionRoleArn"></a>
The Amazon Resource Name (ARN) of the service role with permissions to create a flow. For more information, see [Create a service role for flows in Amazon Bedrock](https://docs.aws.amazon.com/bedrock/latest/userguide/flows-permissions.html) in the Amazon Bedrock User Guide.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 2048.  
Pattern: `arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/(service-role/)?.+` 

 ** [id](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-id"></a>
The unique identifier of the flow.  
Type: String  
Pattern: `[0-9a-zA-Z]{10}` 

 ** [name](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-name"></a>
The name of the version.  
Type: String  
Pattern: `([0-9a-zA-Z][_-]?){1,100}` 

 ** [status](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-status"></a>
The status of the flow.  
Type: String  
Valid Values: `Failed | Prepared | Preparing | NotPrepared` 

 ** [version](#API_agent_CreateFlowVersion_ResponseSyntax) **   <a name="bedrock-agent_CreateFlowVersion-response-version"></a>
The version of the flow that was created. Versions are numbered incrementally, starting from 1.  
Type: String  
Pattern: `[0-9]{1,5}` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** ConflictException **   
There was a conflict performing an operation.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/CreateFlowVersion) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/CreateFlowVersion) 

# CreateKnowledgeBase


[...]
